#!/usr/bin/perl

#
#		fidogate announce filter 1.0
#
#	      
#	    .
#
#	  :     
#	       newfiles - 
#	    ...
#
#	os_filt.pl "/var/log/fido/fidogate/newfiles" | ftnoutpkt ...
#
#		Oleg Smirnov, 2:5022/128
#

@buff = `cat $ARGV[0]`;

$desc=0;
$file=0;
$number=0;
$g_size=0;
$g_num=0;
foreach $x ( @buff ){
    $x =~ s/\n//g;
    if ( $x =~ /^\=\=\=\=\=\=/ ){
	$file=1;
	$desc=0;
	next;
    }
    if ( $desc ==1 ){
	@f_desc[$number-1] = "@f_desc[$number-1]\n$x";
    }
    if ( $file == 1){
	@file = split(" ", $x);
	@f_name[$number] = @file[0];
	@f_size[$number] = @file[1];
	@f_echo[$number] = @file[2];
	@f_orig[$number] = @file[3];
	@f_from[$number] = @file[4];
	@f_desc[$number] = "";
	$number++;
	$desc=1;
	$file=0;
    }
}

for ( $ckl=0; $ckl<=$number; $ckl++ ){
    @f_desc[$ckl] =~ s/\t/\ \ \ /g;
    @f_desc[$ckl] =~ s/\ \ /\ /g;
    @f_desc[$ckl] =~ s/\ \ /\ /g;
    @f_desc[$ckl] =~ s/\ \ /\ /g;
    @f_desc[$ckl] =~ s/\ \ //g;
}

for ( $ckl=0; $ckl<$number; $ckl++ ){
    if ( @f_echo[$ckl] ne "--post--") { $echo=@f_echo[$ckl]; }
    $go=0;
    $e_size=0;
    $e_num=0;    
    for ( $ckl1=0; $ckl1<$number; $ckl1++ ){
	if ( @f_echo[$ckl1] eq $echo ){
	    if ( $go == 0 ){
		print "\n >> @f_echo[$ckl]\n";
		print " -----------------------------------------------------------------------------\n";
		printf (" %15s %10s ", @f_name[$ckl1], @f_size[$ckl1] );
		$go=1;
		@f_echo[$ckl1] = "--post--";
		$e_size+=@f_size[$ckl1];
		$e_num++;    
	    }else{
		printf (" %15s %10s ", @f_name[$ckl1], @f_size[$ckl1] );
		@f_echo[$ckl1] = "--post--";
		$e_size+=@f_size[$ckl1];
		$e_num++;    
	    }
	    $desc = @f_desc[$ckl1];
	    $desc =~ s/^\n//g;
	    $desc =~ s/\n/\n                            /g;
	    print "$desc\n";
	    print "                             @f_orig[$ckl1] (received from @f_from[$ckl1])\n";
	}
    }
    if ( $go ==1 ){
	print " -----------------------------------------------------------------------------\n";
	print "                $e_size   $e_num ().\n";
	$g_size+=$e_size;
	$g_num+=$e_num;
    }
}

print "\n-+-      $g_size   $g_num ().";
